//-------------------------------------------------------------------
//
//  This code is copyright 2010 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------
//
//       File: cuntdown.js
//       Description: Count down time
//       Author: Golubinets A. (golubinets@g5software.com)

// Default vars init
var dayDiv  = 86400;
var hourDiv = 3600;
var minDiv  = 60;

// Timeout identify
var timeoutIndent;

// Images preload
if (!("countdownTheme" in this))
  countdownTheme = "../theme/";

preload = new Array();
pic0 = new Image();
pic0.src = countdownTheme + "num-0.png";
preload[0] = pic0.src;
pic1 = new Image();
pic1.src = countdownTheme + "num-1.png";
preload[1] = pic1.src;
pic2 = new Image();
pic2.src = countdownTheme + "num-2.png";
preload[2] = pic2.src;
pic3 = new Image();
pic3.src = countdownTheme + "num-3.png";
preload[3] = pic3.src;
pic4 = new Image();
pic4.src = countdownTheme + "num-4.png";
preload[4] = pic4.src;
pic5 = new Image();
pic5.src = countdownTheme + "num-5.png";
preload[5] = pic5.src;
pic6 = new Image();
pic6.src = countdownTheme + "num-6.png";
preload[6] = pic6.src;
pic7 = new Image();
pic7.src = countdownTheme + "num-7.png";
preload[7] = pic7.src;
pic8 = new Image();
pic8.src = countdownTheme + "num-8.png";
preload[8] = pic8.src;
pic9 = new Image();
pic9.src = countdownTheme + "num-9.png";
preload[9] = pic9.src;

function _countdownStartUp(localization, dayto)
{
  var now = new Date();
  countdown(localization, ((dayto.getTime() - now.getTime()) / 1000) - (now.getTimezoneOffset() * 60));
}

function countdownStartUp(localization, year, month, day)
{
  return _countdownStartUp(localization, new Date(year, month - 1, day));
}

function countdown(localization,setupTimeEnd) {
  // Zeroing vars
  var setDay  = 0;
  var setHour = 0;
  var setMin  = 0;
  var setSec  = 0;

  localization = localization.toUpperCase();
  
  var timeEnd = setupTimeEnd;

  var countdownLine = '';
  // Calculate day, hour, mins, sec from secconds stamp
  setDay  =  Math.floor(timeEnd / dayDiv);
  if(setDay > 99)
  {
    //all Maximum
    setDay = 99;
    setHour = 23;
    setMin = 59;
    setSec = 59;
  }
  else
  {
    setHour =  Math.floor((timeEnd - (setDay * dayDiv)) / hourDiv );
    setMin  =  Math.floor((timeEnd - ((setDay * dayDiv) + (setHour * hourDiv))) / minDiv );
    setSec  =  Math.floor(timeEnd  - ((setDay * dayDiv) + (setHour * hourDiv) + (setMin * minDiv)));
  }
  

  // Get time numbers
  if (Math.floor(setDay/10) != 0)
    var day1 = Math.floor(setDay/10);
  else
    var day1 = '';

  var day2 = setDay%10;

  var hourImg1 = Math.floor(setHour/10);
  var hourImg2 = setHour%10;

  var minImg1 = Math.floor(setMin/10);
  var minImg2 = setMin%10;

  var secImg1 = Math.floor(setSec/10);
  var secImg2 = setSec%10 ;
  if (day1 == '')
  {
    countdownLine = '<img src="' + countdownTheme + 'counter_01_'+localization+'.png" />';
    countdownLine += '<div class="mainbox"><div style="width:16px;margin-left:9px"><div><img src="'+ preload[day2] + '" /></div></div><div class="impsep">&nbsp;</div><div><img src="'+ preload[hourImg1] + '" /></div><div><img src="'+ preload[hourImg2] + '" /></div><div class="sep" align="center"><div style="width:4px;"><img src="' + countdownTheme + 'space.png" /></div></div><div><img src="'+ preload[minImg1] + '" /></div><div><img src="'+ preload[minImg2] + '" /></div><div class="sep" align="center"><div style="width:4px;"><img src="' + countdownTheme + 'space.png" /></div></div><div><img src="'+ preload[secImg1] + '" /></div><div><img src="'+ preload[secImg2] + '" /></div></div>';
    document.getElementById('countdown').innerHTML = countdownLine;
  }
  else
  {
    countdownLine = '<img src="' + countdownTheme + 'counter_01_'+localization+'.png" />';
    countdownLine += '<div class="mainbox"><div><img src="'+ preload[day1] + '"/></div><div><img src="'+ preload[day2] + '" /></div><div class="impsep">&nbsp;</div><div><img src="'+ preload[hourImg1] + '" /></div><div><img src="'+ preload[hourImg2] + '" /></div><div class="sep" align="center"><div style="width:4px;"><img src="' + countdownTheme + 'space.png" /></div></div><div><img src="'+ preload[minImg1] + '" /></div><div><img src="'+ preload[minImg2] + '" /></div><div class="sep" align="center"><div style="width:4px;"><img src="' + countdownTheme + 'space.png" /></div></div><div><img src="'+ preload[secImg1] + '" /></div><div><img src="'+ preload[secImg2] + '" /></div></div>';
    document.getElementById('countdown').innerHTML = countdownLine;
  }
    
  if (timeEnd <= 0)
  {
    document.getElementById('countbox').innerHTML = '';
    clearTimeout(timeoutIndent);
    return false;
  }
  else
    timeEnd--;
  
  timeoutIndent = setTimeout(function () {
    countdown(localization,timeEnd);
    },1000);
  return true;
}

window.onunload = function () { clearTimeout(timeoutIndent); };

////// Example to init timer
// <div id="countdown" class="countdown"></div>
// <script>
//   window.onload = countdownStartUp('RU',2011,6,9); // locale, year, mounth, day
// </script>
