//-------------------------------------------------------------------
//
//  This code is copyright 2010 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------
//
//         File: footer.js
//  Description: 
//       Author: Davidovich V. (ringo@g5software.com)

var defaultTabIndex = 1;
var backButton;

function showBack() 
{
  var flag = true;
  var id = window.localStorage.getItem('xpromo.id');
  if(id != null)
  {
    var temp_array = id.split('.');
    if(inArray('android', temp_array) && !inArray('amzn', temp_array) && !inArray('nook', temp_array) && !inArray('smsn', temp_array) && !inArray('vdfn', temp_array))
    {
      var nav = navigator.userAgent;
      nav = nav.toLowerCase();
      if(nav.indexOf('android') != -1)
      {
         if(nav.indexOf(' bnrv') == -1 || nav.indexOf(' bntv') == -1 || nav.indexOf(' nook ') == -1)
          flag = false;
      }
    }
  }
  if(flag)
  backButton.style.display = 'block';

  // $HACK can't make onstorage work on iphone
  handleStorageEvent();
}

function hideBack() 
{
  backButton.style.display = 'none';
}

var tabs;

function setTab(tab)
{
  // Remove classes from other active nodes
  for (var k = 0, l = tabs.length; k < l; k++)
    removeClass(tabs[k], "active");
          
  // Add active to self
  if (tab)
    addClass(tab, "active");

  // $HACK can't make onstorage work on iphone
  handleStorageEvent();
}

var badgeNews;

function setBadgeNewsValue(_value)
{
  if (!badgeNews)
    return;
    
  badgeNews.style.display = (_value && _value != 0) ? 'block' : 'none';
  badgeNews.innerHTML     = _value;
}

function handleStorageEvent()
{
  setBadgeNewsValue(window.localStorage.getItem("xpromo.news.unread"));
}

function init()
{
  backButton = document.getElementById("backButton");
  hideBack();  

  badgeNews = document.querySelector("p.news span");
  handleStorageEvent();

  // download data
  if (badgeNews != null)
  {
    newsFetch(function(xpromoNews)
    {
      handleStorageEvent();
    });
  }

  tabs = nativeFooter();
  addClass(tabs[defaultTabIndex], "active");
}

// Mimic native footer UI
function nativeFooter()
{
  changeCssClass();
  // Target element
  var footer = document.querySelector("#footer");
  if (footer) 
  {
    // Prevent scrolling on this element
    footer.ontouchmove = 
      function(event)
      {
        event.preventDefault();
      }

    // Grab all 'tabs'
    var tabs = footer.getElementsByTagName("p");
    for (var i = 0, j = tabs.length; i < j; i++) 
    {
      var tab = tabs[i];
      
      // Add active class on touch
      tab.addEventListener("click", 
        function() 
        {
          if (this.innerHTML.indexOf("@tab(") != -1)
            setTab(this);
        }, false);
    }

    return tabs;
  }
}

function changeCssClass()
{
  var div_footer = document.getElementById("footer");
  var attr = div_footer.getAttribute('class');
  var flag = false;
  if(attr == null)
    attr = '';
  //#TODO: optimize letter
  if(attr.indexOf('big') == -1 && attr.indexOf('small') == -1)
  {
    var add_atrr = 'big';
    if(window.localStorage.getItem('xpromo.ui.footer.size') == 25)
      add_atrr = 'small';
    if(attr != '')
    {
      attr += ' ' + add_atrr;
    }
    else
    {
      attr = add_atrr;
    }
    div_footer.setAttribute('class', attr);
    setZoomed(0);
  }
}

// Fire on load
window.addEventListener("load", init, false);
