//-------------------------------------------------------------------
//
//  This code is copyright 2010 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------
//
//         File: home.js
//  Description: 
//       Author: Davidovich V. (ringo@g5software.com)

with (window.localStorage)
{
  if (getItem("xpromo") == null ||
      getItem("xpromo") == "test")
  {
    setItem("xpromo",                "test");
    setItem("xpromo.id",             "com.g5e.xpromodemo");
    setItem("xpromo.games.self.id",  "com.g5e.islandcastaway.android");
    setItem("xpromo.games.count",    "4");
    setItem("xpromo.games.0.id",  "com.g5e.islandcastaway.android");
    setItem("xpromo.games.1.id",  "com.g5e.specialenquiry.android");
    setItem("xpromo.games.2.id",  "com.g5e.smm.android");
    setItem("xpromo.games.3.id",  "com.g5e.virtualcitysb.android");
  }
}

for (id in xpromoGames)
{
  try
  {
    var game = xpromoGames[id];
    game.id   = id;
    game.date = new Date(game.date);
    if (!("doomed" in game))
      game.doomed = -1;
  }
  catch (e)
  {
    delete xpromoGames[id];
  }
}

var homeDirective = 
{
  "a" : 
  {
    "game<-games" : 
    {
      "@href+"   : "game.id",
      "img@src" : function(arg) {
        return "http://xpromo.g5e.com/v1/" + arg.item.id + "/home.jpg";
      }
    }
  }
}

var dataHomeGallery = {};
var dataHomeThumbs  = {};

function homeRender() {
  var wIw = window.innerWidth;
  var wIh = window.innerHeight;
  var container = $p("#container")[0];
  var globalDiv = $p("#global")[0];
  var zm = Math.min(wIw / container.clientWidth, wIh / container.clientHeight);
  if(zm == 0)
  {
    setTimeout(homeRender, 500);
  }
  else
  {

  document.body.style.zoom = zm * 100 + "%";
  globalDiv.style.width = wIw / zm + "px";
  globalDiv.style.height = wIh / zm + "px";
  var games = new Array(parseInt(window.localStorage.getItem("xpromo.games.count")));
  for (var i = 0; i < games.length; i++)
    games[i] = xpromoGames[window.localStorage.getItem("xpromo.games." + i + ".id")];
  // filter unavailable games
  var self_id = gamesSelfId();
  if(games.length < 5)
    self_id = ''; //hack for self promo
  games = games.filter(function(element, index, array)
  {
    if(element != null)
      return element.id != self_id;
    return false;
  });
  var virtualcitysb = games.filter(function(element, index, array)
  {
    return (element.id.indexOf('com.g5e.virtualcitysb') != -1)
  });
  games = games.sort(function(a, b) {
    b = (b.doomed < 0) ? new Date(0) : b.date;
    a = (a.doomed < 0) ? new Date(0) : a.date;

    return b - a;
  });
  var games_backup = games.slice(0, games.length);
  var curDate = new Date();
  games = games.filter(function(element, index, array) {
    return (element.date <= curDate)
  });
  if(games.length < 4 && games_backup.length > 3)
  {
    games_backup = games_backup.filter(function(element, index, array)
    {
      return -1 == games.indexOf(element);
    });
    games.reverse();
    games_backup.reverse();
    games = games.concat(games_backup);
    games.reverse();
  }
  games = games.filter(function (element, index, array) {
    return (-1 == virtualcitysb.indexOf(element));
  });
  games = virtualcitysb.concat(games);
  games = games.slice(0, 4);
  dataHomeThumbs.games = games;
  $p("#thumbs").autoRender(dataHomeThumbs, homeDirective);
  var thumbs    = jQuery("#thumbs a");
  thumbs.eq(3).clone().appendTo('#gallery');

  var userAgent = navigator.userAgent.toLowerCase();
  var badClient = (userAgent.indexOf("ipad")   != -1) &&
                  (userAgent.indexOf("os 3_2") != -1);
  var veryBad   = (userAgent.indexOf("android") != -1);
  duration = veryBad ? 0 : 1;
  show();

  function show() {
    var tmp = thumbs.eq(0).children('img');
    var tmp2 = jQuery("#thumbs");
    var tmp3 = jQuery("#gallery");
    var tmp4 = jQuery("#gl_gallery");
    var tmp5 = jQuery("#gl_thumbs");
    var height_tmp = tmp.height() + 6;
    var height_tmp2 = tmp4.height() + 5;
    thumbs.eq(0).clone().appendTo('#gallery');
    var height_tmp3 = tmp.height() * 3 + 12;
    tmp5.css('height', height_tmp3);
    tmp4.find('img').css('height', height_tmp3);
    if(duration == 0)
    {
      thumbs.eq(0).appendTo('#thumbs');
      tmp3.find('a').eq(0).remove();
      thumbs    = jQuery("#thumbs a");
      setTimeout(function(){show()}, 5000);
    }
    else
    {
      tmp2.css({
        "-webkit-transition-duration": "2s",
        "-webkit-transform": "translateY(-" + height_tmp + "px)"
      });
      tmp3.css({
        "-webkit-transition-duration": "2s",
        "-webkit-transform": "translateY(-" + height_tmp2 + "px)"
      });
      setTimeout(function(){
        thumbs.eq(0).appendTo('#thumbs');
        tmp2.css({
          "-webkit-transition-duration": "0s",
          "-webkit-transform": "translateY(0)"
        });
        tmp3.find('a').eq(0).remove();
        tmp3.css({
          "-webkit-transition-duration": "0s",
          "-webkit-transform": "translateY(0)"
        });
        thumbs    = jQuery("#thumbs a");
        setTimeout(function(){show()}, 5000);
      }, 2050);
    }
  }
  }
}

function gamesSelfId()
{
  var result = window.localStorage.getItem("xpromo.games.self.id");
  if (null == result)
    result = window.localStorage.getItem("xpromo.id");

  return result;
}