//-------------------------------------------------------------------
//
//  This code is copyright 2010 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------
//
//         File: lockit.js
//  Description: 
//       Author: Davidovich V. (ringo@g5software.com)

var count_setZoomed = 0;
var timer_setZoomed = null;

String.prototype.get = function(p)
{
  return (match = this.match(new RegExp("[?|&]?" + p + "=([^&]*)"))) ? match[1] : null;
}

var lockitXHR;

function lockitLoadLangs(_title)
{
  if (!lockitXHR)
    lockitXHR = new XMLHttpRequest();

  with (lockitXHR)
  {
    open("GET", _title + ".txt", false);
    send(null);

    if (responseText)
    {
      try
      {
        return JSON.parse(responseText.replace(/[\r\n]/g, ''));
      }
      catch (e)
      {
        console.log(e);
      }
    }
  }

  return null;
}

function lockitGetLang()
{
  var lang = window.location.search.get("lang");
  
  if (!lang)
    lang = window.localStorage.getItem("xpromo.lang");

  if (!lang)
  {
    if (navigator.userLanguage)
      lang = navigator.userLanguage;
    else
    if (navigator.language)
      lang = navigator.language.split("-")[0];
  }
  window.localStorage.setItem("xpromo.lang", lang);
  return lang;  
}

function lockitGet(_data)
{
  if (_data)
  {
    var english = _data["lang.en"];
    var lang    = lockitGetLang();
    var result  = _data["lang." + lang];

    if (!result)
    {
      result = english;
      lang   = "en";
    }
    else
    if (result != english)
    {
      for (var k in english)
        if (!result.hasOwnProperty(k))
          result[k] = english[k];
    }

    if (result)
      result.lang = lang;

    return result;
  }

  return null;
}

var lockitCache = {};

function lockitLoad(_title)
{
  var result = lockitCache[_title];
  if (result == undefined)
  {
    result = lockitGet(lockitLoadLangs(_title));;
    lockitCache[_title] = result;
  }

  return result;
}

function lockitRenderData(_data)
{
  if (_data)
  {
    for (var sel in _data)
    {
      var elements = document.querySelectorAll(sel);
      for (var i in elements)
        elements[i].innerHTML = _data[sel];
    }
  }

  return _data;
}

var lockitThis = lockitLoad(document.title);
if(lockitThis != null)
{
  if ("title" in lockitThis)
  {
    document.title = lockitThis["title"];
    delete lockitThis["title"];
  }
}

function lockitRender()
{
  var userAgent = navigator.userAgent.toLowerCase();
  if(userAgent.indexOf("android 4") != -1)
  {
    document.body.style["font-size"] = "100%";
  }
  return lockitRenderData(lockitThis);
}

//
// Common utils
//

// Adds class name to element
function addClass(element, elClass) 
{
  var curr = element.className;
  if (!new RegExp(("(^|\\s)" + elClass + "(\\s|$)"), "i").test(curr)) 
  {
    element.className = curr + ((curr.length > 0) ? " " : "") + elClass;
  }
  return element;
}

// Removes class name from element
function removeClass(element, elClass) 
{
  if (elClass) 
  {
    element.className = element.className.replace(elClass, "");
  }
  else 
  {
    element.className = "";
    element.removeAttribute("class");
  }
  return element;
}

function getPlatformFromId(id)
{
  var temp_array = id.split('.');
  if (inArray('android', temp_array) == true)
  {
    return 'android'
  }
  else
  if (inArray('hd', temp_array) == true)
  {
    return 'ipad'
  }
  else
  if (inArray('mac', temp_array) == true)
  {
    return 'mac'
  }
  else
  if (inArray('pc', temp_array) == true)
  {
    return 'pc'
  }
  else
  {
    return 'iphone'
  }
}

function inArray(needle, haystack)
{ 
  var length = haystack.length; 
  for (var i = 0; i < length; i++)
    if (haystack[i] == needle) 
      return true; 

  return false; 
}

function iconNameFor(game_id, variant)
{
  var result = 'icon';
  if (variant)
    result += variant;

  var platform = getPlatformFromId(game_id);
  if (platform == 'mac')
    result += '.png';
  else
    result += '.jpg';

  result += "?v=1";
  return result;
}

function iconStyleFor(game_id, scale)
{
  var result = '', platform = getPlatformFromId(game_id);
  if (!scale)
    scale = 1;

  if (platform == 'android')
  {
    result = ';-webkit-border-radius: ' + scale * 4 + 'px;';
  }
  else 
  if (platform == 'mac')
  {
    result = ';background-color: transparent; -webkit-box-shadow: none; -webkit-border-radius: 0;';
  }
  return result;
}

function setZoomed(a, b) {
  if (a == undefined || a == null)
    a = 0;
  if (b == undefined || b == null)
    b = 0;
  var zm = window.localStorage.getItem('xpromo.ui.zoom');
  if (zm == null || zm == 0)
  {
    a++;
    if (a < 15)
    {
      setTimeout('setZoomed(' + a + ',' + b + ')', 500);
    }
    else
    {
      timeoutSetZoomed(b);
    }
  }
  else
  {
    //parseFloat(zm);
    var userAgent = navigator.userAgent.toLowerCase();
    var pixelRatio = window.devicePixelRatio;
    if (pixelRatio == undefined)
      pixelRatio = 1;
    zm = zm / pixelRatio;
    if (b == 1)
    {
      //var inWidth = getRealSize();
      var inWidth = window.innerWidth;
      //inWidth = inWidth * zm;
      if (userAgent.indexOf("(macintosh;") != -1)
      {
        if (inWidth == 800 && zm == 1)
        {
          zm = zm / 2;
        }
      }
    }
    zm = zm / 2;
    document.body.style.zoom = zm * 100 + '%';
    if (userAgent.indexOf("android 4") == -1)
    {
      document.body.style["font-size"] = document.body.style.zoom;
    }
    timeoutSetZoomed(b);
  }
}

function timeoutSetZoomed(b) {
  count_setZoomed++;
  window.clearTimeout(timer_setZoomed);
  if (count_setZoomed < 10)
  {
    timer_setZoomed = window.setTimeout('setZoomed(0,' + b + ')', 500);
  }
  else
  {
    timer_setZoomed = window.setTimeout('setZoomed(0,' + b + ')', 1000 * count_setZoomed);
  }
}

function isIpadNewFunc() {
  var IsiPad = navigator.userAgent.indexOf("iPad") != -1 ;
  if(IsiPad)
  {
    var ratio = window.devicePixelRatio;
    if(ratio != undefined)
    {
      ratio = parseInt(ratio);
      if(ratio >= 2)
        return true;
    }
  }
  return false;
}

function getRealSize() {
  var ret = 0;
  var pixelRatio = window.devicePixelRatio;
  if(pixelRatio == undefined)
    pixelRatio = 1;
  if (window.screen.width == 0)
  {
    ret = document.width;
    if (pixelRatio == 2)
      ret = ret * pixelRatio;
  }
  else
  if (window.outerWidth == 0)
  {
    ret = window.innerWidth;
  }
  else
  if(window.outerWidth != window.innerWidth)
  {
    ret = document.documentElement.clientWidth;
  }
  else
  {
    ret = window.screen.width;
  }
  return ret;
}

function convertLink(link, GRID) {
  if (link.indexOf('@ext(') != -1)
  {
    if (link.indexOf('phobos.apple.com') != -1)
    {
      var tmp = link.replace('@ext(', '');
      tmp = tmp.replace(')','');
      return '@ext(http://target.georiot.com/Proxy.ashx?GRID=' + GRID + '&GR_URL=' + encodeURIComponent(tmp) + ')';
    }
  }
   return link;
}