//-------------------------------------------------------------------
//
//  This code is copyright 2010 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------
//
//         File: news_fetch.js
//  Description: 
//       Author: Davidovich V. (ringo@g5software.com)

var XPROMO_SITE = "http://xpromo.g5e.com/v1/";
var NEWS_SITE   = XPROMO_SITE + "news/";

with (window.localStorage)
{
  if (!getItem("xpromo.news.read"))
    setItem("xpromo.news.read", "");

  var newsBase = getItem("xpromo.news.base");
  if (newsBase)
    NEWS_SITE = XPROMO_SITE + newsBase;
}

function newsFetch(_onload)
{
  with (new XMLHttpRequest())
  {
    open("GET", NEWS_SITE + ".txt", true);
    onreadystatechange = function()
    {
      if (readyState != 4)
        return;

      var text;
      if (status == 200 ||
          responseText) // for local GET to work
      {
        text = responseText.replace(/[\r\n]/g, '');
        window.localStorage.setItem("xpromo.news", text);
      }
      else
      {
        text = window.localStorage.getItem("xpromo.news");
      }

      if (text)
      {
        var thisDate = new Date().getTime();
        var endDate, beginDate;
        var newsUnread = 0;
        var newsRead   = window.localStorage.getItem("xpromo.news.read");
        var xpromoNews = JSON.parse(text);
        for (var id in xpromoNews)
        {
          var record = xpromoNews[id];
          var isRead = ((newsRead + ";").indexOf(id) != -1);

          record.id   = id;
          record.href = record.href;
          record.date = record.date;
          record.kind = isRead ? "read" : "unrd";
          beginDate = new Date(record.date).getTime();
          //if(parseInt(thisDate.format('Ymd')) < parseInt(beginDate.format('Ymd')))
          if(thisDate < beginDate)
              continue;
          if(record.date_end != undefined)
          {
            endDate = new Date(record.date_end).getTime();
            if(thisDate >= endDate)
              continue;
          }

          if (!isRead)
            newsUnread++;
        }

        window.localStorage.setItem("xpromo.news.unread", newsUnread);
        _onload(xpromoNews);
      }
    }
    send(null);
  }
}
