// MIT Licensed!
// @url: http://jacwright.com/projects/javascript/date_format
// @author:  Tomas Theunissen, D'n Russler
// @date: 9/29/2010
// @description: Simulates PHP's date function
Date.prototype.format=function(format){var returnStr='';var replace=Date.replaceChars;for(var i=0;i<format.length;i++){var curChar=format.charAt(i);if(i-1>=0&&format.charAt(i-1)=="\\"){returnStr+=curChar;}else if(replace[curChar]){returnStr+=replace[curChar].call(this);}else if(curChar!="\\"){returnStr+=curChar;}}return returnStr;};Date.replaceChars={shortMonths:['Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec'],longMonths:['January','February','March','April','May','June','July','August','September','October','November','December'],shortDays:['Sun','Mon','Tue','Wed','Thu','Fri','Sat'],longDays:['Sunday','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday'],d:function(){return(this.getDate()<10?'0':'')+this.getDate();},D:function(){return Date.replaceChars.shortDays[this.getDay()];},j:function(){return this.getDate();},l:function(){return Date.replaceChars.longDays[this.getDay()];},N:function(){return this.getDay()+1;},S:function(){return(this.getDate()%10==1&&this.getDate()!=11?'st':(this.getDate()%10==2&&this.getDate()!=12?'nd':(this.getDate()%10==3&&this.getDate()!=13?'rd':'th')));},w:function(){return this.getDay();},z:function(){var d=new Date(this.getFullYear(),0,1);return Math.ceil((this-d)/86400000);},W:function(){var d=new Date(this.getFullYear(),0,1);return Math.ceil((((this-d)/86400000)+d.getDay()+1)/7);},F:function(){return Date.replaceChars.longMonths[this.getMonth()];},m:function(){return(this.getMonth()<9?'0':'')+(this.getMonth()+1);},M:function(){return Date.replaceChars.shortMonths[this.getMonth()];},n:function(){return this.getMonth()+1;},t:function(){var d=new Date();return new Date(d.getFullYear(),d.getMonth(),0).getDate()},L:function(){var year=this.getFullYear();return(year%400==0||(year%100!=0&&year%4==0));},o:function(){var d=new Date(this.valueOf());d.setDate(d.getDate()-((this.getDay()+6)%7)+3);return d.getFullYear();},Y:function(){return this.getFullYear();},y:function(){return(''+this.getFullYear()).substr(2);},a:function(){return this.getHours()<12?'am':'pm';},A:function(){return this.getHours()<12?'AM':'PM';},B:function(){return Math.floor((((this.getUTCHours()+1)%24)+this.getUTCMinutes()/60+this.getUTCSeconds()/3600)*1000/24);},g:function(){return this.getHours()%12||12;},G:function(){return this.getHours();},h:function(){return((this.getHours()%12||12)<10?'0':'')+(this.getHours()%12||12);},H:function(){return(this.getHours()<10?'0':'')+this.getHours();},i:function(){return(this.getMinutes()<10?'0':'')+this.getMinutes();},s:function(){return(this.getSeconds()<10?'0':'')+this.getSeconds();},u:function(){var m=this.getMilliseconds();return(m<10?'00':(m<100?'0':''))+m;},e:function(){return"Not Yet Supported";},I:function(){return"Not Yet Supported";},O:function(){return(-this.getTimezoneOffset()<0?'-':'+')+(Math.abs(this.getTimezoneOffset()/60)<10?'0':'')+(Math.abs(this.getTimezoneOffset()/60))+'00';},P:function(){return(-this.getTimezoneOffset()<0?'-':'+')+(Math.abs(this.getTimezoneOffset()/60)<10?'0':'')+(Math.abs(this.getTimezoneOffset()/60))+':00';},T:function(){var m=this.getMonth();this.setMonth(0);var result=this.toTimeString().replace(/^.+ \(?([^\)]+)\)?$/,'$1');this.setMonth(m);return result;},Z:function(){return-this.getTimezoneOffset()*60;},c:function(){return this.format("Y-m-d\\TH:i:sP");},r:function(){return this.toString();},U:function(){return this.getTime()/1000;}};

//
//  This code is copyright 2010 by G5 Entertainment AB.
//  Any unauthorized usage, either in part or in whole of this code
//  is strictly prohibited. Violators WILL be prosecuted to the
//  maximum extent allowed by law.
//
//-------------------------------------------------------------------
//
//       File: promoKit.js
//       Author: Golubinets A. (Alexandr.Golubinets@g5e.com)


String.prototype.get = function(p)
{
  return (match = this.match(new RegExp("[?|&]?" + p + "=([^&]*)"))) ? match[1] : null;
}

var promoKitXHR;

function promoKitLoadLangs(_title)
{
  if (!promoKitXHR)
    promoKitXHR = new XMLHttpRequest();

  with (promoKitXHR)
  {
    open("GET", _title + ".txt", false);
    send(null);
    if (responseText)
    {
      try
      {
        return JSON.parse(responseText.replace(/[\r\n]/g, ''));
      }
      catch (e)
      {
        console.log(e);
      }
    }
  }
  return null;
}

function promoKitGetLang()
{
  var lang = window.location.search.get("lang");

  if (!lang)
    lang = window.localStorage.getItem("xpromo.lang");

  if (!lang)
  {
    if (navigator.userLanguage)
      lang = navigator.userLanguage;
    else
    if (navigator.language)
      lang = navigator.language.split("-")[0];
  }

  return lang;  
}


function promoKitGet(_data, lang)
{
  if (_data)
  {
    var thisDate = new Date();
    var english = _data["lang.en"];
    
    if (lang == undefined)
      lang = promoKitGetLang();
    
    
    var result  = _data["lang." + lang];

    if (!result)
    {
      result = english;
      lang   = "en";
    }
    else
    if (result != english)
    {
      for (var k in english)
        if (!result.hasOwnProperty(k))
          result[k] = english[k];
    }
    
    // loop dates
    for (var key in result.content)
    {
      var dateSets = result.content[key];
      var begsAt = new Date(dateSets.begsAt);
      var endsAt = new Date(dateSets.endsAt);
      if ((thisDate.format('Ymd') >= begsAt.format('Ymd')) && (thisDate.format('Ymd') < endsAt.format('Ymd')))
      {
        return dateSets;
      }
    } 
    
    return null;
  }

  return null;
}

var promoKitCache = {};

function promoKitLoad(_title, lang)
{
  var result = promoKitCache[_title];
  if (result == undefined)
  {
    result = promoKitGet(promoKitLoadLangs(_title), lang);
    promoKitCache[_title] = result;
  }

  return result;
}

// set data
function promoKitRenderData(_data)
{
  if (_data)
  {
    for (var sel in _data)
    {
      var elements = document.querySelectorAll(sel);
      for (var i in elements)
        elements[i].innerHTML = _data[sel];
    }
    
    $("a.promolink").attr('href', _data.href);
    if (_data.promoicon != '')
      $("img.promoicon").attr('src', _data.promoicon);
    else 
      $("img.promoicon").remove();
  }
  return _data;
}

function promoKitRender(fileRender, lang)
{
  var promoKitThis = promoKitLoad(fileRender, lang);
  return promoKitRenderData(promoKitThis);
}
